<template>
  <div class="timeline">
    <h3>Calendário</h3>
    <div v-for="e in events" :key="e.date" class="event">
      <div class="e-dot"></div>
      <div class="e-line"></div>
      <div class="e-card">
        <div class="ec-date">{{ formatDate(e) }}</div>
        <div class="ec-text">{{ e.text }}</div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    events: {
      type: Array,
      required: true
    }
  },
  methods: {
    formatDate(event) {
      if (!event.endDate) return event.date;

      const [start, end] = [event.date, event.endDate];
      const [sDay, sMonth, sYear] = start.split("/"),
        [eDay, eMonth, eYear] = end.split("/");

      if (sYear === eYear) if (sMonth === eMonth) return `${sDay} a ${end}`;
      return `${sDay}/${sMonth} a ${end}`;
    }
  }
};
</script>

<style lang="postcss">
.event {
  height: 6rem;

  display: grid;
  grid-template-rows: 1fr 1fr;
  grid-template-columns: 1fr 4fr;
}

.e-dot {
  @apply bg-black rounded;

  grid-row: 1/2;
  grid-column: 1/2;
  justify-self: center;
  align-self: center;

  width: 50%;
  height: 20%;
}

.e-line {
  @apply bg-black;

  grid-row: 1/3;
  grid-column: 1/2;
  justify-self: center;

  width: 20%;
}

.e-card {
  grid-row: 1/3;
  grid-column: 2/3;

  display: grid;
  grid-template-rows: 1fr 2fr;
  grid-template-columns: 1fr;
  grid-template-areas:
    "date"
    "text";

  @apply text-sm;
}

.ec-date {
  grid-area: date;
  align-self: center;
  font-weight: bold;
  color: black;
}

.ec-text {
  @apply text-left text-base;
  grid-area: text;
}

@screen md {
  .event {
    height: 7rem;
  }

  .e-line {
    width: 10%;
  }
}

@screen lg {
  .timeline {
    width: 35%;
  }

  .event {
    height: 6rem;
  }

  .ec-text {
    @apply text-xl;
  }
}
</style>
